' ping.bas - ping host by ip or hostname
' written by Rich Martin (datawiz) August 2020
'
option explicit
option default none

#include "esp8266var.inc"

dim COM_PORT$ = "COM2"								' replace with the COM port you have the esp connected to
dim COM_SPEED$ = "115200"							' default baud rate for the esp
dim COM_BUFFER$ = "256"
dim x%
dim C$ = ""

if mm.cmdline$ = "" then
	print "Error: missing host or ip to ping. Try: *ping <host or ip address>"
	print "example: *ping 8.8.8.8"
	print "         *ping www.google.com"
	end
end if

esp.var.com.filenum% = 5
open COM_PORT$+":"+COM_SPEED$+","+COM_BUFFER$+",esp.input.loop" as esp.var.com.filenum%

esp.var.echo% = 0
esp.echo.set("OFF")
esp.var.waitfor.mode% = esp.waitfor.mode.normal
esp.tcp.client.ping(mm.cmdline$)
esp.var.timeout% = 10000
if esp.var.return$ <> "" then print "> timeout" : end
x% = instr(1,esp.var.waitfor.buffer$,chr$(&H0D))
C$ = mid$(esp.var.waitfor.buffer$,2,x%-2)
if val(C$) <> 0 then
	print "> responded in ";C$;" ms"
else
	print "> no response"
end if
close esp.var.com.filenum%
end

#include "esp8266lib.inc"


