' simpleterm.bas - a very simple terminal program showing how to use the esp8266 library for the cmm2
' written by Rich Martin (datawiz) August 2020
'
option explicit
option default none

#include "esp8266var.inc"

dim SERVER_IP$  = "192.168.1.100"			' replace with the IP/hostname you want to connect to
dim SERVER_PORT$= "6000"							' replace with the PORT you want to connect to
dim COM_PORT$ = "COM2"								' replace with the COM port you have the esp connected to
dim COM_SPEED$ = "115200"							' default baud rate for the esp
dim COM_BUFFER$ = "256"
dim C$ = ""

cls
print "Welcome to simpleterm - a sample program using the esp8266 library"
print "press @ to connect to host, - to disconnect, and ^ to quit."
print "AT commands to the esp8266 are active now.
print

' open com port to esp8266
esp.var.com.filenum% = 6
open COM_PORT$+":"+COM_SPEED$+","+COM_BUFFER$+",esp.input.loop" as esp.var.com.filenum%

' tell esp.input.loop to not output recieved data from esp
esp.var.echo% = 0
' in case we are in transparent mode, escape out and close connection
esp.wifi.escape("AT+CIPCLOSE")

' set esp to echo back our input
esp.echo.set("ON")
' set esp.input.loop to output received data from esp
esp.var.echo% = 1
' set esp.input.loop mode to normal output (output data received byte by byte)
esp.var.waitfor.mode% = esp.waitfor.mode.normal

' handle input
do
  C$ = INKEY$
  if C$ <> "" then 
    select case C$
      case "@"
        esp.var.echo% = 0
        esp.tcp.client.connect(SERVER_IP$, SERVER_PORT$)
        esp.var.echo% = 1
        if esp.var.return$ = "" then print "-> Connected"
        if esp.var.return$ <> "" then print "-> Connect failed"
      case "-"
        esp.var.echo% = 0
        esp.wifi.escape("AT+CIPCLOSE")
        pause 1000
        print "-> Disconnected"
        esp.var.echo% = 1
      case "^"
        print "-> Quit"
        exit
      case else
        print #esp.var.com.filenum%, C$;
        if esp.var.crlf% = 1 and ASC(C$) = 10 then print #5, chr$(13);
    end select
  end if
loop

esp.var.echo% = 0
esp.wifi.escape("AT+CIPCLOSE")
pause 1000
close esp.var.com.filenum%
end

#include "esp8266lib.inc"


